# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageActionRun(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_pages': 'int',
        'total_elements': 'int',
        'first': 'bool',
        'last': 'bool',
        'sort': 'PageActionSort',
        'number': 'int',
        'number_of_elements': 'int',
        'pageable': 'PageActionPageable',
        'size': 'int',
        'content': 'list[PageActionRunContent]',
        'empty': 'bool'
    }

    attribute_map = {
        'total_pages': 'totalPages',
        'total_elements': 'totalElements',
        'first': 'first',
        'last': 'last',
        'sort': 'sort',
        'number': 'number',
        'number_of_elements': 'numberOfElements',
        'pageable': 'pageable',
        'size': 'size',
        'content': 'content',
        'empty': 'empty'
    }

    def __init__(self, total_pages=None, total_elements=None, first=None, last=None, sort=None, number=None, number_of_elements=None, pageable=None, size=None, content=None, empty=None):  # noqa: E501
        """PageActionRun - a model defined in Swagger"""  # noqa: E501
        self._total_pages = None
        self._total_elements = None
        self._first = None
        self._last = None
        self._sort = None
        self._number = None
        self._number_of_elements = None
        self._pageable = None
        self._size = None
        self._content = None
        self._empty = None
        self.discriminator = None
        if total_pages is not None:
            self.total_pages = total_pages
        if total_elements is not None:
            self.total_elements = total_elements
        if first is not None:
            self.first = first
        if last is not None:
            self.last = last
        if sort is not None:
            self.sort = sort
        if number is not None:
            self.number = number
        if number_of_elements is not None:
            self.number_of_elements = number_of_elements
        if pageable is not None:
            self.pageable = pageable
        if size is not None:
            self.size = size
        if content is not None:
            self.content = content
        if empty is not None:
            self.empty = empty

    @property
    def total_pages(self):
        """Gets the total_pages of this PageActionRun.  # noqa: E501


        :return: The total_pages of this PageActionRun.  # noqa: E501
        :rtype: int
        """
        return self._total_pages

    @total_pages.setter
    def total_pages(self, total_pages):
        """Sets the total_pages of this PageActionRun.


        :param total_pages: The total_pages of this PageActionRun.  # noqa: E501
        :type: int
        """

        self._total_pages = total_pages

    @property
    def total_elements(self):
        """Gets the total_elements of this PageActionRun.  # noqa: E501


        :return: The total_elements of this PageActionRun.  # noqa: E501
        :rtype: int
        """
        return self._total_elements

    @total_elements.setter
    def total_elements(self, total_elements):
        """Sets the total_elements of this PageActionRun.


        :param total_elements: The total_elements of this PageActionRun.  # noqa: E501
        :type: int
        """

        self._total_elements = total_elements

    @property
    def first(self):
        """Gets the first of this PageActionRun.  # noqa: E501


        :return: The first of this PageActionRun.  # noqa: E501
        :rtype: bool
        """
        return self._first

    @first.setter
    def first(self, first):
        """Sets the first of this PageActionRun.


        :param first: The first of this PageActionRun.  # noqa: E501
        :type: bool
        """

        self._first = first

    @property
    def last(self):
        """Gets the last of this PageActionRun.  # noqa: E501


        :return: The last of this PageActionRun.  # noqa: E501
        :rtype: bool
        """
        return self._last

    @last.setter
    def last(self, last):
        """Sets the last of this PageActionRun.


        :param last: The last of this PageActionRun.  # noqa: E501
        :type: bool
        """

        self._last = last

    @property
    def sort(self):
        """Gets the sort of this PageActionRun.  # noqa: E501


        :return: The sort of this PageActionRun.  # noqa: E501
        :rtype: PageActionSort
        """
        return self._sort

    @sort.setter
    def sort(self, sort):
        """Sets the sort of this PageActionRun.


        :param sort: The sort of this PageActionRun.  # noqa: E501
        :type: PageActionSort
        """

        self._sort = sort

    @property
    def number(self):
        """Gets the number of this PageActionRun.  # noqa: E501


        :return: The number of this PageActionRun.  # noqa: E501
        :rtype: int
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this PageActionRun.


        :param number: The number of this PageActionRun.  # noqa: E501
        :type: int
        """

        self._number = number

    @property
    def number_of_elements(self):
        """Gets the number_of_elements of this PageActionRun.  # noqa: E501


        :return: The number_of_elements of this PageActionRun.  # noqa: E501
        :rtype: int
        """
        return self._number_of_elements

    @number_of_elements.setter
    def number_of_elements(self, number_of_elements):
        """Sets the number_of_elements of this PageActionRun.


        :param number_of_elements: The number_of_elements of this PageActionRun.  # noqa: E501
        :type: int
        """

        self._number_of_elements = number_of_elements

    @property
    def pageable(self):
        """Gets the pageable of this PageActionRun.  # noqa: E501


        :return: The pageable of this PageActionRun.  # noqa: E501
        :rtype: PageActionPageable
        """
        return self._pageable

    @pageable.setter
    def pageable(self, pageable):
        """Sets the pageable of this PageActionRun.


        :param pageable: The pageable of this PageActionRun.  # noqa: E501
        :type: PageActionPageable
        """

        self._pageable = pageable

    @property
    def size(self):
        """Gets the size of this PageActionRun.  # noqa: E501


        :return: The size of this PageActionRun.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this PageActionRun.


        :param size: The size of this PageActionRun.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def content(self):
        """Gets the content of this PageActionRun.  # noqa: E501


        :return: The content of this PageActionRun.  # noqa: E501
        :rtype: list[PageActionRunContent]
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this PageActionRun.


        :param content: The content of this PageActionRun.  # noqa: E501
        :type: list[PageActionRunContent]
        """

        self._content = content

    @property
    def empty(self):
        """Gets the empty of this PageActionRun.  # noqa: E501


        :return: The empty of this PageActionRun.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this PageActionRun.


        :param empty: The empty of this PageActionRun.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageActionRun, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageActionRun):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
